## skytools 2.1.6

=== Makefile ===

-include config.mak

PYTHON ?= python

pyver = $(shell $(PYTHON) -V 2>&1 | sed 's/^[^ ]* \([0-9]*\.[0-9]*\).*/\1/')

SUBDIRS = sql doc

all: python-all modules-all

modules-all: config.mak
	$(MAKE) -C sql all

python-all: config.mak
	$(PYTHON) setup.py build

clean:
	$(PYTHON) setup.py clean
	$(MAKE) -C sql clean
	$(MAKE) -C doc clean
	rm -rf build
	find python -name '*.py[oc]' -print | xargs rm -f
	rm -f python/skytools/installer_config.py
	rm -rf tests/londiste/sys
	rm -rf tests/londiste/file_logs
	rm -rf tests/londiste/fix.*
	rm -rf tests/scripts/sys

install: python-install modules-install

installcheck:
	$(MAKE) -C sql installcheck

modules-install: config.mak
	$(MAKE) -C sql install DESTDIR=$(DESTDIR)
	test \! -d compat || $(MAKE) -C compat $@ DESTDIR=$(DESTDIR)

python-install: config.mak modules-all
	$(PYTHON) setup.py install --prefix=$(prefix) --root=$(DESTDIR)/
	make -C doc DESTDIR=$(DESTDIR) install

python-install python-all: python/skytools/installer_config.py
python/skytools/installer_config.py: python/skytools/installer_config.py.in config.mak
	sed -e 's!@SQLDIR@!$(SQLDIR)!g' $< > $@


distclean: clean
	for dir in $(SUBDIRS); do $(MAKE) -C $$dir $@ || exit 1; done
	$(MAKE) -C doc $@
	rm -rf source.list dist skytools-*
	find python -name '*.pyc' | xargs rm -f
	rm -rf dist build
	rm -rf autom4te.cache config.log config.status config.mak

deb80:
	./configure --with-pgconfig=/usr/lib/postgresql/8.0/bin/pg_config
	sed -e s/PGVER/8.0/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

deb81:
	./configure --with-pgconfig=/usr/lib/postgresql/8.1/bin/pg_config
	sed -e s/PGVER/8.1/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

deb82:
	./configure --with-pgconfig=/usr/lib/postgresql/8.2/bin/pg_config
	sed -e s/PGVER/8.2/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

deb83:
	./configure --with-pgconfig=/usr/lib/postgresql/8.3/bin/pg_config
	sed -e s/PGVER/8.3/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

tgz: config.mak clean
	make -C doc man
	$(PYTHON) setup.py sdist -t source.cfg -m source.list

debclean: distclean
	rm -rf debian/tmp-* debian/build* debian/control debian/packages-tmp*
	rm -f debian/files debian/rules debian/sub* debian/packages

boot: configure

configure: configure.ac
	autoconf


.PHONY: all clean distclean install deb debclean tgz
.PHONY: python-all python-clean python-install

=== doc/Makefile ===

include ../config.mak

wiki = https://developer.skype.com/SkypeGarage/DbProjects/SkyTools

web = mkz@shell.pgfoundry.org:/home/pgfoundry.org/groups/skytools/htdocs/

EPYDOC = epydoc-py25
EPYARGS = --no-private --url="http://pgfoundry.org/projects/skytools/" \
	--name="Skytools" --html --no-private -v

HTMLS = londiste.cmdline.html londiste.config.html README.html INSTALL.html \
	londiste.ref.html TODO.html pgq-sql.html pgq-admin.html pgq-nodupes.html \
	$(SCRIPT_HTMLS)

SCRIPT_TXTS = walmgr.txt cube_dispatcher.txt table_dispatcher.txt \
	      queue_mover.txt queue_splitter.txt bulk_loader.txt \
	      scriptmgr.txt skytools_upgrade.txt
SCRIPT_MANS = $(SCRIPT_TXTS:.txt=.1)
SCRIPT_HTMLS = $(SCRIPT_TXTS:.txt=.html)

COMMON = common.switches.txt common.config.txt common.logutriga.txt

GETATTRS = python ./getattrs.py

all: man

man: londiste.1 londiste.5 pgqadm.1 $(SCRIPT_MANS)

html: $(HTMLS)

install: man
	mkdir -p $(DESTDIR)/$(mandir)/man1
	mkdir -p $(DESTDIR)/$(mandir)/man5
	install -m 644 londiste.1 $(DESTDIR)/$(mandir)/man1
	install -m 644 londiste.5 $(DESTDIR)/$(mandir)/man5
	install -m 644 pgqadm.1 $(DESTDIR)/$(mandir)/man1
	for m in $(SCRIPT_MANS); do \
	  install -m 644 $$m $(DESTDIR)/$(mandir)/man1 ; \
	done

old.wiki.upload:
	devupload.sh overview.txt $(wiki)
	#devupload.sh TODO.txt $(wiki)/ToDo
	#devupload.sh londiste.txt $(wiki)/LondisteUsage
	#devupload.sh londiste.ref.txt $(wiki)/LondisteReference
	#devupload.sh pgq-sql.txt $(wiki)/PgQdocs
	#devupload.sh pgq-nodupes.txt $(wiki)/PgqNoDupes
	#devupload.sh walmgr.txt $(wiki)/WalMgr
	#devupload.sh pgq-admin.txt $(wiki)/PgqAdm

PY_PKGS = skytools pgq londiste

#	skytools.config skytools.dbstruct skytools.gzlog \
#	skytools.quoting skytools.scripting skytools.sqltools \
#	pgq pgq.consumer pgq.event pgq.maint pgq.producer pgq.status pgq.ticker \
#	londiste londiste.compare londiste.file_read londiste.file_write \
#	londiste.installer londiste.playback londiste.repair londiste.setup \
#	londiste.syncer londiste.table_copy

apidoc:
	rm -rf api
	mkdir -p api
	cd ../python && $(EPYDOC) $(EPYARGS) -o ../doc/api $(PY_PKGS)

apiupload: apidoc
	rsync -rtlz api/* $(web)/api
	cd ../sql/pgq && rm -rf docs/html && $(MAKE) dox
	rsync -rtlz ../sql/pgq/docs/html/* $(web)/pgq/

clean:
	rm -rf api *.html

distclean: clean
	rm -rf ../sql/pgq/docs/pgq

realclean: distclean
	rm -f *.[15] *.xml

ifneq ($(XMLTO),)
londiste.1: londiste.cmdline.xml
	$(XMLTO) man $<

londiste.5: londiste.config.xml
	$(XMLTO) man $<

pgqadm.1: pgq-admin.xml
	$(XMLTO) man $<

walmgr.1: walmgr.xml
	$(XMLTO) man $<
endif

ifneq ($(ASCIIDOC),)
%.xml: %.txt $(COMMON)
	$(ASCIIDOC) -b docbook -d manpage `$(GETATTRS) $<` -o - $< \
	| python fixman.py > $@

%.1: %.xml
	$(XMLTO) man $<

%.html: %.txt $(COMMON)
	$(ASCIIDOC) -a toc `$(GETATTRS) $<` $<

README.html: ../README
	cat $< \
	| sed -e 's,doc/\([!-~]*\)[.]txt,link:\1.html[],g' \
	      -e 's,http:[!-~]*,&[],g' \
	| $(ASCIIDOC) -o $@ -

INSTALL.html: ../INSTALL
	$(ASCIIDOC) -o $@ $<
endif

web: $(HTMLS)
	rsync -avz $(HTMLS) $(web)/doc/

## skytools 2.1.7

=== upgrade/Makefile ===

#SQLS = v2.1.5_londiste.sql  v2.1.5_pgq_core.sql  v2.1.5_pgq_ext.sql
#SQLS = v2.1.6_londiste.sql  v2.1.6_pgq_ext.sql
SQLS = v2.1.7_pgq_core.sql v2.1.7_londiste.sql

SRCS = $(addprefix src/, $(SQLS))
DSTS = $(addprefix final/, $(SQLS))

CATSQL = python ../scripts/catsql.py

all: $(DSTS)

final/%.sql: src/%.sql
	$(CATSQL) $< > $@

=== sql/pgq/Makefile ===

DOCS = README.pgq
DATA_built = pgq.sql pgq.upgrade.sql
DATA = structure/uninstall_pgq.sql

SRCS = $(wildcard structure/*.sql) \
       $(wildcard functions/*.sql) \
       $(wildcard triggers/*.sql) \
       lowlevel/pgq_lowlevel.sql \
       triggers/pgq_triggers.sql

REGRESS = pgq_init pgq_core logutriga sqltriga
REGRESS_OPTS = --load-language=plpgsql

include ../../config.mak
include $(PGXS)

NDOC = NaturalDocs
NDOCARGS = -r -o html docs/html -p docs -i docs/sql
CATSQL = ../../scripts/catsql.py

SUBDIRS = lowlevel triggers

# PGXS does not have subdir support, thus hack to recurse into lowlevel/
all: sub-all
install: sub-install
clean: sub-clean
distclean: sub-distclean
sub-all sub-install sub-clean sub-distclean:
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $(subst sub-,,$@) DESTDIR=$(DESTDIR); \
	done

lowlevel/pgq_lowlevel.sql: sub-all
triggers/pgq_triggers.sql: sub-all

#
# combined SQL files
#

pgq.sql: $(SRCS)
	$(CATSQL) structure/install.sql > $@

pgq.upgrade.sql: $(SRCS)
	$(CATSQL) structure/func_internal.sql structure/func_public.sql > $@

#
# docs
#
dox: cleandox $(SRCS)
	mkdir -p docs/html
	mkdir -p docs/sql
	$(CATSQL) --ndoc structure/tables.sql structure/types.sql > docs/sql/schema.sql
	$(CATSQL) --ndoc structure/func_public.sql > docs/sql/external.sql
	$(CATSQL) --ndoc structure/func_internal.sql > docs/sql/internal.sql
	$(CATSQL) --ndoc structure/triggers.sql > docs/sql/triggers.sql
	$(NDOC) $(NDOCARGS)

cleandox:
	rm -rf docs/html docs/Data docs/sql

clean: cleandox

upload: dox
	rsync -az --delete docs/html/* data1:public_html/pgq-new/

#
# regtest shortcuts
#

test: pgq.sql
	$(MAKE) installcheck || { less regression.diffs; exit 1; }

ack:
	cp results/*.out expected/

=== sql/txid/Makefile ===

include ../../config.mak

PGVER := $(shell $(PG_CONFIG) --version | sed 's/PostgreSQL //')

ifeq ($(PGVER),)
$(error skytools not configured, cannot continue)
else
# postgres >= manages epoch itself, so skip epoch tables
pg83 = $(shell test $(PGVER) "<" "8.3" && echo "false" || echo "true")
pg82 = $(shell test $(PGVER) "<" "8.2" && echo "false" || echo "true")
endif

ifeq ($(pg83),true)  # we have 8.3 with internal txid

# nothing to do

else # 8.2 or 8.1
#
# pg < 8.3 needs this module
#
MODULE_big = txid
SRCS = txid.c epoch.c
OBJS = $(SRCS:.c=.o)
REGRESS = txid
REGRESS_OPTS = --load-language=plpgsql
DATA = uninstall_txid.sql
DOCS = README.txid
DATA_built = txid.sql
EXTRA_CLEAN = txid.sql.in

ifeq ($(pg82),true)
# 8.2 tracks epoch internally
TXID_SQL = txid.std.sql
else
# 8.1 needs epoch-tracking code
TXID_SQL = txid.std.sql txid.schema.sql
endif # ! 8.2
endif # ! 8.3

# PGXS build procedure
include $(PGXS)

# additional deps
txid.o: txid.h
epoch.o: txid.h

txid.sql.in: $(TXID_SQL)
	cat $(TXID_SQL) > $@

test: install
	make installcheck || { less regression.diffs; exit 1; }

=== sql/pgq/triggers/Makefile ===

include ../../../config.mak

MODULE_big = pgq_triggers
SRCS = common.c logtriga.c logutriga.c sqltriga.c makesql.c stringutil.c
OBJS = $(SRCS:.c=.o)
DATA_built = pgq_triggers.sql

include $(PGXS)

cs:
	cscope -b -f .cscope.out *.c

## skytools 2.1.8

=== Makefile ===
--- 
+++ 
@@ -38,12 +38,15 @@
 
 python-install: config.mak modules-all
 	$(PYTHON) setup.py install --prefix=$(prefix) --root=$(DESTDIR)/
-	make -C doc DESTDIR=$(DESTDIR) install
+	$(MAKE) -C doc DESTDIR=$(DESTDIR) install
 
 python-install python-all: python/skytools/installer_config.py
 python/skytools/installer_config.py: python/skytools/installer_config.py.in config.mak
 	sed -e 's!@SQLDIR@!$(SQLDIR)!g' $< > $@
 
+realclean:
+	$(MAKE) -C doc $@
+	$(MAKE) distclean
 
 distclean: clean
 	for dir in $(SUBDIRS); do $(MAKE) -C $$dir $@ || exit 1; done
@@ -78,7 +81,7 @@
 	debuild -uc -us -b
 
 tgz: config.mak clean
-	make -C doc man
+	$(MAKE) -C doc man
 	$(PYTHON) setup.py sdist -t source.cfg -m source.list
 
 debclean: distclean

=== doc/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 web = mkz@shell.pgfoundry.org:/home/pgfoundry.org/groups/skytools/htdocs/
 
-EPYDOC = epydoc-py25
+EPYDOC = epydoc
 EPYARGS = --no-private --url="http://pgfoundry.org/projects/skytools/" \
 	--name="Skytools" --html --no-private -v
 
@@ -77,7 +77,8 @@
 realclean: distclean
 	rm -f *.[15] *.xml
 
-ifneq ($(XMLTO),)
+ifneq ($(ASCIIDOC),no)
+ifneq ($(XMLTO),no)
 londiste.1: londiste.cmdline.xml
 	$(XMLTO) man $<
 
@@ -91,7 +92,6 @@
 	$(XMLTO) man $<
 endif
 
-ifneq ($(ASCIIDOC),)
 %.xml: %.txt $(COMMON)
 	$(ASCIIDOC) -b docbook -d manpage `$(GETATTRS) $<` -o - $< \
 	| python fixman.py > $@

=== sql/logtriga/Makefile ===

include ../../config.mak

MODULE_big = logtriga
SRCS = logtriga.c textbuf.c
OBJS = $(SRCS:.c=.o)
DATA_built = logtriga.sql

REGRESS = logtriga

include $(PGXS)

test: install
	make installcheck || { less regression.diffs; exit 1; }

## skytools 2.1.8-2.2~bpo50+2

=== debian/changelog ===
skytools (2.1.8-2.2~bpo50+2) lenny-backports; urgency=low

  * Reupload with new key.

 -- Christoph Berg <myon@debian.org>  Tue, 19 Apr 2011 11:50:54 +0200

skytools (2.1.8-2.2~bpo50+1) lenny-backports; urgency=low

  * Rebuild for lenny-backports.

 -- Christoph Berg <myon@debian.org>  Fri, 25 Mar 2011 14:32:40 +0100

skytools (2.1.8-2.2) unstable; urgency=low

  * Non-maintainer upload.
  * debian/{control, rules}
    - use pysupport to manage the Python module, so also compiling it; thanks to
      Luca Falavigna for the report; Closes: #566047
  * debian/{control, rules, *.links, *.install}
    - support only PostgreSQL 8.4; thanks to Martin Pitt for the report;
      Closes: #559606
  * debian/rules
    - added simple-patchsys.mk rule
    - added python-distutils.mk class
  * debian/patches/missing_includes.diff
    - added missing includes, fixing the FTBFS with PostgreSQL 8.4
  * skytools.install
    - don't hardcode 'python2.5' and 'site-package', use globbing instead
  * patches/rename_as_for_python2.6.diff
    - added to replace 'as', since it's a reserved word in Python 2.6; thanks to
      Fabrice Coutadeur for the report; Closes: #535144
  * debian/skytools-modules-8.4.install
    - added installation of files from 'debian/tmp/usr/share/skytools' needed
      for the module to look for SQL files; thanks to Marc Cousin for the
      report and Chris Lamb for the patch; Closes: #534310
  * debian/control
    - replaced explicit Depends on 'python' with substvar ${python:Depends}
    - build-depends on python-all-dev, to be built against all support Python

 -- Sandro Tosi <morph@debian.org>  Sat, 13 Feb 2010 10:46:11 +0100

skytools (2.1.8-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Specify PG_CONFIG directly so that paths relating to Postgres 8.4 are not
    returned, preventing a FTBFS. (Closes: #536906)

 -- Chris Lamb <lamby@debian.org>  Tue, 11 Aug 2009 08:20:10 +0100

skytools (2.1.8-2) unstable; urgency=low

  * Dependency changes psycopg to psycopg2, because psycopg isn't support 
    upstream. (Closes: #518223)
  * Added README.source

 -- Fernando Ike de Oliveira <fike@midstorm.org>  Wed, 04 Mar 2009 18:39:29 -0300

skytools (2.1.8-1) unstable; urgency=low

  * New upstream release. 

 -- Fernando Ike de Oliveira <fike@midstorm.org>  Fri, 09 Jan 2009 15:17:14 -0200

skytools (2.1.7-1) unstable; urgency=low

  * New upstream release
  * Fixed itens relationship bug #479685: (Closes: #479685)
    + Added manpage of bulk_loader, cube_dispatcher, londsite, pgqadm,
      queue_mover, queue_splitter, scriptmgr, skytools_upgrade, table_dispacher
      and walmgr.
    + Added NEWS and README.
    + Better written field short description to skytools-modules and 
      skytools in the control file.
    + Better written field long description to skytools-modules and skytools.

 -- Fernando Ike de Oliveira <fike@midstorm.org>  Sat, 07 Jun 2008 20:39:15 -0300

skytools (2.1.6-1) unstable; urgency=low

  * Initial release. (Closes: #427871)

 -- Fernando Ike de Oliveira <fike@midstorm.org>  Fri, 27 Jul 2007 04:00:06 -0300

=== debian/control ===
Source: skytools
Maintainer: Fernando Ike de Oliveira <fike@midstorm.org>
Uploaders: Christoph Berg <myon@debian.org>
Section: misc
Priority: optional
Standards-Version: 3.8.0
Build-Depends: python-all-dev, postgresql-server-dev-8.4, cdbs (>= 0.4.38), 
 debhelper (>= 7), xmlto, asciidoc, python-support
Homepage: http://pgfoundry.org/projects/skytools/
XS-Python-Version: >= 2.5
Vcs-Svn: svn://svn.debian.org/pkg-postgresql/trunk/skytools/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-postgresql/trunk/skytools/

Package: skytools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-psycopg2, 
 skytools-modules-8.4
Description: Database management tools from Skype to PostgreSQL 
 Skytools are database management tools to WAL shipping, queueing and 
 replication. This package has Python parts of skytools:
 .
  - londiste - PostgreSQL replication engine written in Python
  - pgqadm - PgQ tickter and administration interface
  - walmgr - Tools for managing WAL-based replication for PostgreSQL.

Package: skytools-modules-8.4
Architecture: any
Depends:  ${shlibs:Depends}, ${misc:Depends}, postgresql-8.4
Description: PostgreSQL modules of skytools
 Skytools are database management tools to WAL shipping, queuing and 
 replication. This package has PostgreSQL modules skytools:
 .
  - txid: Provides 8-byte transaction id-s for external usage
  - logtriga: Trigger function for table event logging in "partial SQL" 
    format, used in londsite for replication
  - logutriga - Trigger function for table event logging in 
    urlencoded format
  - pgq: Python framework for PgQ consumers

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/simple-patchsys.mk

DEB_PYTHON_SYSTEM := pysupport
include /usr/share/cdbs/1/class/python-distutils.mk


DEB_CONFIGURE_EXTRA_FLAGS := --prefix=/usr PG_CONFIG=/usr/lib/postgresql/8.4/bin/pg_config
DEB_INSTALL_DOCS_ALL := doc/TODO.txt NEWS README
DEB_INSTALL_MANPAGES_skytools := doc/*.1 doc/*.5

DEB_DH_SHLIBDEPS_ARGS_ALL=--dpkg-shlibdeps-params=--ignore-missing-info

install/skytools::
	for I in debian/tmp/usr/bin/*; \
		do \
			mv $$I $${I%.py} ; \
	done

## skytools 2.1.12

=== Makefile ===
--- 
+++ 
@@ -37,12 +37,12 @@
 	test \! -d compat || $(MAKE) -C compat $@ DESTDIR=$(DESTDIR)
 
 python-install: config.mak modules-all
-	$(PYTHON) setup.py install --prefix=$(prefix) --root=$(DESTDIR)/
+	$(PYTHON) setup.py install --prefix=$(prefix) --root=$(DESTDIR)/ $(BROKEN_PYTHON)
 	$(MAKE) -C doc DESTDIR=$(DESTDIR) install
 
 python-install python-all: python/skytools/installer_config.py
 python/skytools/installer_config.py: python/skytools/installer_config.py.in config.mak
-	sed -e 's!@SQLDIR@!$(SQLDIR)!g' $< > $@
+	sed -e 's!@SQLDIR@!$(SQLDIR)!g' -e 's!@PACKAGE_VERSION@!$(PACKAGE_VERSION)!g' $< > $@
 
 realclean:
 	$(MAKE) -C doc $@
@@ -57,26 +57,38 @@
 	rm -rf autom4te.cache config.log config.status config.mak
 
 deb80:
-	./configure --with-pgconfig=/usr/lib/postgresql/8.0/bin/pg_config
+	./configure --with-pgconfig=/usr/lib/postgresql/8.0/bin/pg_config --with-python=$(PYTHON)
 	sed -e s/PGVER/8.0/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
 	yada rebuild
 	debuild -uc -us -b
 
 deb81:
-	./configure --with-pgconfig=/usr/lib/postgresql/8.1/bin/pg_config
+	./configure --with-pgconfig=/usr/lib/postgresql/8.1/bin/pg_config --with-python=$(PYTHON)
 	sed -e s/PGVER/8.1/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
 	yada rebuild
 	debuild -uc -us -b
 
 deb82:
-	./configure --with-pgconfig=/usr/lib/postgresql/8.2/bin/pg_config
+	./configure --with-pgconfig=/usr/lib/postgresql/8.2/bin/pg_config --with-python=$(PYTHON)
 	sed -e s/PGVER/8.2/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
 	yada rebuild
 	debuild -uc -us -b
 
 deb83:
-	./configure --with-pgconfig=/usr/lib/postgresql/8.3/bin/pg_config
+	./configure --with-pgconfig=/usr/lib/postgresql/8.3/bin/pg_config --with-python=$(PYTHON)
 	sed -e s/PGVER/8.3/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
+	yada rebuild
+	debuild -uc -us -b
+
+deb84:
+	./configure --with-pgconfig=/usr/lib/postgresql/8.4/bin/pg_config --with-python=$(PYTHON)
+	sed -e s/PGVER/8.4/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
+	yada rebuild
+	debuild -uc -us -b
+
+deb90:
+	./configure --with-pgconfig=/usr/lib/postgresql/9.0/bin/pg_config --with-python=$(PYTHON)
+	sed -e s/PGVER/9.0/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
 	yada rebuild
 	debuild -uc -us -b
 
@@ -93,6 +105,10 @@
 configure: configure.ac
 	autoconf
 
+# workaround for Debian's broken python
+debfix:
+	$(PYTHON) setup.py install --help | grep -q install-layout \
+	&& echo BROKEN_PYTHON=--install-layout=deb || echo 'WORKING_PYTHON=found'
 
 .PHONY: all clean distclean install deb debclean tgz
 .PHONY: python-all python-clean python-install

=== sql/londiste/Makefile ===

DATA_built = londiste.sql londiste.upgrade.sql
DOCS = README.londiste

FUNCS = $(wildcard functions/*.sql)
SRCS = structure/tables.sql structure/grants.sql structure/types.sql $(FUNCS)

REGRESS = londiste_install londiste_provider londiste_subscriber londiste_fkeys
# londiste_denytrigger
REGRESS_OPTS = --load-language=plpythonu --load-language=plpgsql

include ../../config.mak

include $(PGXS)

londiste.sql: $(SRCS)
	cat $(SRCS) > $@

londiste.upgrade.sql: $(FUNCS)
	cat $(FUNCS) > $@

test: londiste.sql
	$(MAKE) installcheck || { less regression.diffs; exit 1; }

ack:
	cp results/* expected/

=== sql/pgq/Makefile ===
--- 
+++ 
@@ -69,7 +69,7 @@
 #
 
 test: pgq.sql
-	$(MAKE) installcheck || { less regression.diffs; exit 1; }
+	$(MAKE) install installcheck || { less regression.diffs; exit 1; }
 
 ack:
 	cp results/*.out expected/

=== debian/changelog ===
skytools (2.1.12-4ubuntu1) precise; urgency=low

  * debian/skytools-modules-9.1.install: when building pg 9.1 modules, README
    files now end up in /usr/share/doc/postgresql-doc-9.1, so look there for
    the READMEs to install.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 14 Nov 2011 16:36:33 -0500

skytools (2.1.12-4) unstable; urgency=low

  * Support building for all available PostgreSQL versions. Thanks to
    Dimitri Fontaine for the patch!

 -- Christoph Berg <myon@debian.org>  Thu, 08 Sep 2011 11:15:25 +0200

skytools (2.1.12-3) unstable; urgency=low

  * Rebuild for PostgreSQL 9.1.

 -- Christoph Berg <myon@debian.org>  Wed, 24 Aug 2011 11:13:04 +0200

skytools (2.1.12-2) unstable; urgency=low

  * Section: database.
  * Make londiste scriptmgr queue_mover queue_splitter walmgr "alternatives"
    to cooperate with the skytools3 package.
  * Conflicts/Replaces: postgresql-PGVERSION-pgq3, also for skytools3.

 -- Christoph Berg <myon@debian.org>  Fri, 01 Apr 2011 10:07:59 +0200

skytools (2.1.12-1) unstable; urgency=low

  * New maintainer.
  * Include NMU changes by Sandro Tosi, thanks!
  * New upstream version. Closes: #604711
  * Convert to dh 7 and 3.0 (quilt).
  * Support building for multiple postgresql versions in parallel, add 9.0
    package.
  * Improve descriptions a bit. Closes: #569991

 -- Christoph Berg <myon@debian.org>  Wed, 30 Mar 2011 16:21:31 +0200

skytools (2.1.10-1) unstable; urgency=low

  * New update release.
  * Change dependency build to PostgreSQL 8.4. (Closes: #559606) 

 -- Fernando Ike de Oliveira <fike@midstorm.org>  Tue, 15 Dec 2009 18:41:17 -0200

=== debian/control ===
Source: skytools
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christoph Berg <myon@debian.org>
Section: database
Priority: optional
Standards-Version: 3.9.2
Build-Depends: python-all-dev, postgresql-server-dev-all (>= 119~),
 debhelper (>= 7.0.50~), xmlto, asciidoc
Homepage: http://wiki.postgresql.org/wiki/Skytools
Vcs-Svn: svn://svn.debian.org/pkg-postgresql/trunk/skytools/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-postgresql/trunk/skytools/

Package: skytools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-psycopg2,
 skytools-modules
# /usr/share/skytools moved here
Replaces: skytools-modules-8.4 (<< 2.1.12)
Description: Database management tools for PostgreSQL
 Skytools is a set of PostgreSQL tools for WAL shipping, queueing and
 replication.
 .
 This package contains the Python parts of skytools:
  - londiste: PostgreSQL replication engine written
  - pgqadm: PgQ queueing administration interface
  - walmgr: Managing WAL-based replication

Package: skytools-modules-9.1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.1
Provides: skytools-modules
Conflicts: postgresql-9.1-pgq3
Replaces: postgresql-9.1-pgq3
Description: PostgreSQL 9.1 modules for skytools
 Skytools is a set of PostgreSQL tools for WAL shipping, queueing and
 replication.
 .
 This package contains the PostgreSQL modules for skytools:
  - txid: Provides 8-byte transaction ids for external usage
  - logtriga: Trigger function for table event logging in "partial SQL"
    format, used in londsite for replication
  - logutriga: Trigger function for table event logging in
    urlencoded format
  - londiste: Database parts of replication engine
  - pgq: Generic queue in database

=== debian/rules ===
#!/usr/bin/make -f

PG_CONFIG_91=/usr/lib/postgresql/9.1/bin/pg_config

# Rebuild debian/control
SRCDIR = .
include /usr/share/postgresql-common/pgxs_debian_control.mk
# force rebuilding
.PHONY: debian/control

clean: debian/control

override_dh_auto_clean:
	# eeks, clean needs a working config.mak file
	[ -s config.mak ] || ./configure --prefix=/usr PG_CONFIG=/usr/lib/postgresql/9.1/bin/pg_config
	dh_auto_clean

build:
	dh_prep
	#./configure --prefix=/usr PG_CONFIG=/usr/lib/postgresql/8.4/bin/pg_config
	#$(MAKE) modules-all
	#$(MAKE) modules-install DESTDIR=$(CURDIR)/debian/tmp BROKEN_PYTHON=--install-layout=deb
	#$(MAKE) clean
	./configure --prefix=/usr PG_CONFIG=$(PG_CONFIG_91)
	$(MAKE)
	# for version in $$(pg_buildext supported-versions .) ; do \
	# 	echo "### Building for PostgreSQL $$version"; \
	# 	$(MAKE) install; \
	# done

override_dh_prep:

override_dh_auto_install:
	BROKEN_PYTHON=--install-layout=deb dh_auto_install -- PG_CONFIG=$(PG_CONFIG_91)
	for version in $$(pg_buildext supported-versions .) ; do \
		echo "### Building for PostgreSQL $$version" && \
		./configure --prefix=/usr \
			PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config && \
		for d in sql/pgq sql/pgq_ext sql/txid sql/londiste sql/logtriga ; do \
			$(MAKE) DESTDIR=$(CURDIR)/debian/tmp -C $$d clean install || exit 1 ;\
		done; \
	done
	for I in debian/tmp/usr/bin/* ; do \
		mv $$I $${I%.py} || exit 1 ; \
	done
	# interaction with skytools3
	for I in londiste scriptmgr queue_mover queue_splitter walmgr ; do \
		mv debian/tmp/usr/bin/$$I debian/tmp/usr/bin/$${I}2 || exit 1 ; \
		mv debian/tmp/usr/share/man/man1/$$I.1 debian/tmp/usr/share/man/man1/$${I}2.1 || exit 1 ; \
	done

%:
	dh $@ --with python2

=== debian/watch ===
version=3
http://pgfoundry.org/frs/?group_id=1000206 /frs/download.php/[0-9]+/skytools-([0-9.]+).tar.gz debian uupdate

## skytools 2.1.13

=== Makefile ===
--- 
+++ 
@@ -92,6 +92,12 @@
 	yada rebuild
 	debuild -uc -us -b
 
+deb91:
+	./configure --with-pgconfig=/usr/lib/postgresql/9.1/bin/pg_config --with-python=$(PYTHON)
+	sed -e s/PGVER/9.1/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
+	yada rebuild
+	debuild -uc -us -b
+
 tgz: config.mak clean
 	$(MAKE) -C doc man
 	$(PYTHON) setup.py sdist -t source.cfg -m source.list

=== doc/Makefile ===
--- 
+++ 
@@ -90,14 +90,14 @@
 
 walmgr.1: walmgr.xml
 	$(XMLTO) man $<
-endif
 
 %.xml: %.txt $(COMMON)
 	$(ASCIIDOC) -b docbook -d manpage `$(GETATTRS) $<` -o - $< \
-	| python fixman.py > $@
+	| cat > $@
 
 %.1: %.xml
 	$(XMLTO) man $<
+endif
 
 %.html: %.txt $(COMMON)
 	$(ASCIIDOC) -a toc `$(GETATTRS) $<` $<

=== sql/Makefile ===

include ../config.mak

SUBDIRS = logtriga londiste pgq pgq_ext txid

all install clean distclean installcheck:
	for dir in $(SUBDIRS); do \
	  $(MAKE) -C $$dir $@ DESTDIR=$(DESTDIR) || exit $?; \
	done

=== upgrade/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 
 #SQLS = v2.1.5_londiste.sql  v2.1.5_pgq_core.sql  v2.1.5_pgq_ext.sql
 #SQLS = v2.1.6_londiste.sql  v2.1.6_pgq_ext.sql
-SQLS = v2.1.7_pgq_core.sql v2.1.7_londiste.sql
+#SQLS = v2.1.7_pgq_core.sql v2.1.7_londiste.sql
+SQLS = v2.1.8_pgq_core.sql
 
 SRCS = $(addprefix src/, $(SQLS))
 DSTS = $(addprefix final/, $(SQLS))

=== sql/pgq/Makefile ===
--- 
+++ 
@@ -28,7 +28,8 @@
 distclean: sub-distclean
 sub-all sub-install sub-clean sub-distclean:
 	for dir in $(SUBDIRS); do \
-		$(MAKE) -C $$dir $(subst sub-,,$@) DESTDIR=$(DESTDIR); \
+		$(MAKE) -C $$dir $(subst sub-,,$@) DESTDIR=$(DESTDIR) \
+		|| exit 1; \
 	done
 
 lowlevel/pgq_lowlevel.sql: sub-all

=== sql/pgq_ext/Makefile ===

DOCS = README.pgq_ext
DATA_built = pgq_ext.sql

SRCS = structure/tables.sql functions/track_batch.sql functions/track_event.sql \
       functions/track_tick.sql functions/version.sql

REGRESS = test_pgq_ext
REGRESS_OPTS = --load-language=plpgsql

include ../../config.mak

include $(PGXS)

pgq_ext.sql: $(SRCS)
	cat $(SRCS) > $@

test: pgq_ext.sql
	make installcheck || { less regression.diffs ; exit 1; }

ack:
	cp results/* expected/

=== sql/txid/Makefile ===
--- 
+++ 
@@ -13,7 +13,11 @@
 
 ifeq ($(pg83),true)  # we have 8.3 with internal txid
 
-# nothing to do
+# create empty file
+txid.sql:
+	echo > txid.sql
+
+EXTRA_CLEAN = txid.sql.in txid.sql
 
 else # 8.2 or 8.1
 #

=== tests/quoting/Makefile ===

test:
	PYTHONPATH=`echo ../../build/lib.*` \
	./regtest.py

=== sql/pgq/lowlevel/Makefile ===

include ../../../config.mak

MODULE_big = pgq_lowlevel
DATA_built = pgq_lowlevel.sql

SRCS = insert_event.c
OBJS = $(SRCS:.c=.o)

include $(PGXS)

=== debian/changelog ===
skytools (2.1.13-4) unstable; urgency=medium

  [ Martin Pitt ]
  * Add missing "build-needed" autopkgtest restriction.

 -- Christoph Berg <myon@debian.org>  Fri, 14 Feb 2014 21:53:56 +0100

skytools (2.1.13-3) unstable; urgency=low

  * Fix .install files for 8.x; port to 9.3.  Closes: #724194.
  * Repository moved to git.
  * Ignore changes on generated doc/ files.
  * Add autopkgtest support.

 -- Christoph Berg <myon@debian.org>  Tue, 22 Oct 2013 00:11:30 +0200

skytools (2.1.13-2) unstable; urgency=low

  * Add words missing in the londiste description.  Closes: #676649.
    Spotted by Beatrice Torracca, thanks!
  * Add 9.2 to supported versions.

 -- Christoph Berg <myon@debian.org>  Tue, 12 Jun 2012 15:58:49 +0200

skytools (2.1.13-1) unstable; urgency=low

  * New upstream release.
  * Remove object files in sql/ on clean.
  * Update watch file to only catch 2.x versions.

 -- Christoph Berg <myon@debian.org>  Tue, 20 Mar 2012 16:18:54 +0100

skytools (2.1.12-6) unstable; urgency=low

  * 2.1 is on community support and doesn't release anymore. Import
    changes from tag skytools_2_1_12 to branch skytools_2_1_stable from
    upstream git.
    + Bugfix psycopgwrapper connect_database() to open a cursor before using
      it
    + Synch walmgr changes from 3.0 branch.
    + Add support for detecting stale locks and releasing them instead of
      aborting
    + Move the pg_stop_backup() into a finally: block.
    + londiste add-table: make trigger check sql 9.1-compatible
    + pgq.insert_event: Fix rare crash
    + pgq.triggers: Fix potential rare crash.
    + pgq: fix unnecessary failures in regtests
  * Remove \i txid.sql from regression tests so they run through.
    Additionally, the server config needs bytea_output = 'escape'.

 -- Christoph Berg <myon@debian.org>  Fri, 16 Dec 2011 11:23:55 +0100

skytools (2.1.12-5) unstable; urgency=low

  * Fix 9.1 build.  Closes: #646666
  * Add 8.2 and 8.3 to supported versions.

 -- Christoph Berg <myon@debian.org>  Sat, 05 Nov 2011 20:06:50 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: skytools
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christoph Berg <myon@debian.org>
+Maintainer: Christoph Berg <myon@debian.org>
 Section: database
 Priority: optional
-Standards-Version: 3.9.2
+Standards-Version: 3.9.5
 Build-Depends: python-all-dev, postgresql-server-dev-all (>= 119~),
  debhelper (>= 7.0.50~), xmlto, asciidoc
 Homepage: http://wiki.postgresql.org/wiki/Skytools
-Vcs-Svn: svn://svn.debian.org/pkg-postgresql/trunk/skytools/
-Vcs-Browser: http://svn.debian.org/wsvn/pkg-postgresql/trunk/skytools/
+Vcs-Git: git://anonscm.debian.org/pkg-postgresql/skytools.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-postgresql/skytools.git
+XS-Testsuite: autopkgtest
 
 Package: skytools
 Architecture: any
@@ -22,16 +22,17 @@
  .
  This package contains the Python parts of skytools:
   - londiste: PostgreSQL replication engine written
+    Python, using PgQ as event transport
   - pgqadm: PgQ queueing administration interface
   - walmgr: Managing WAL-based replication
 
-Package: skytools-modules-9.1
+Package: skytools-modules-9.3
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.1
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.3
 Provides: skytools-modules
-Conflicts: postgresql-9.1-pgq3
-Replaces: postgresql-9.1-pgq3
-Description: PostgreSQL 9.1 modules for skytools
+Conflicts: postgresql-9.3-pgq3
+Replaces: postgresql-9.3-pgq3
+Description: PostgreSQL 9.3 modules for skytools
  Skytools is a set of PostgreSQL tools for WAL shipping, queueing and
  replication.
  .

=== debian/rules ===
#!/usr/bin/make -f

PG_CONFIG=$(shell ls /usr/lib/postgresql/*/bin/pg_config | tail -n1)

# Rebuild debian/control
SRCDIR = .
include /usr/share/postgresql-common/pgxs_debian_control.mk
# force rebuilding
.PHONY: debian/control

clean: debian/control

override_dh_auto_clean:
	# eeks, clean needs a working config.mak file
	[ -s config.mak ] || ./configure --prefix=/usr PG_CONFIG=$(PG_CONFIG)
	make distclean
	rm -f doc/londiste.cmdline.xml doc/londiste.config.xml doc/pgq-admin.xml doc/walmgr.xml
	find sql -name '*.o' -or -name '*.a' -or -name '*.so*' | xargs -r rm

override_dh_auto_configure:
	#./configure --prefix=/usr PG_CONFIG=/usr/lib/postgresql/8.4/bin/pg_config
	#$(MAKE) modules-all
	#$(MAKE) modules-install DESTDIR=$(CURDIR)/debian/tmp BROKEN_PYTHON=--install-layout=deb
	#$(MAKE) clean
	./configure --prefix=/usr PG_CONFIG=$(PG_CONFIG)
	#+pg_buildext configure build-%v "--prefix"

override_dh_auto_build:
	$(MAKE)
	#+pg_buildext build $(CURDIR) build-%v
	# for version in $$(pg_buildext supported-versions .) ; do \
	# 	echo "### Building for PostgreSQL $$version"; \
	# 	$(MAKE) install; \
	# done
	# manually add plpython dependencies for autopkgtest (we could
	# probably make skytools-modules-* depend on postgresql-plpython-*, but
	# that's not needed for basic operation)
	sed -i -e "s/postgresql-plpython.*/postgresql-plpython/" debian/tests/control
	for version in $$(pg_buildext supported-versions) ; do \
		sed -i -e "s/postgresql-plpython/postgresql-plpython, postgresql-plpython-$$version/" debian/tests/control ; \
	done

override_dh_auto_test:
	# real testing is done with autopkgtest

override_dh_auto_install:
	BROKEN_PYTHON=--install-layout=deb dh_auto_install -- PG_CONFIG=$(PG_CONFIG)
	#+pg_buildext install build-%v skytools-modules-%v
	for version in $$(pg_buildext supported-versions .) ; do \
		echo "### Building for PostgreSQL $$version" && \
		./configure --prefix=/usr \
			PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config && \
		for d in sql/pgq sql/pgq_ext sql/txid sql/londiste sql/logtriga ; do \
			$(MAKE) DESTDIR=$(CURDIR)/debian/tmp -C $$d clean install || exit 1 ;\
		done; \
	done
	for I in debian/tmp/usr/bin/* ; do \
		mv $$I $${I%.py} || exit 1 ; \
	done
	# interaction with skytools3
	set -e; for I in londiste scriptmgr queue_mover queue_splitter walmgr; do \
		mv debian/tmp/usr/bin/$$I debian/tmp/usr/bin/$${I}2; \
		mv debian/tmp/usr/share/man/man1/$$I.1 debian/tmp/usr/share/man/man1/$${I}2.1; \
	done

%:
	dh $@ --with python2

=== debian/tests/control ===
Depends: @, postgresql-server-dev-all, postgresql-plpython, postgresql-plpython-9.3
Tests: installcheck
Restrictions: needs-root build-needed allow-stderr

=== debian/watch ===
version=3
http://pgfoundry.org/frs/?group_id=1000206 /frs/download.php/[0-9]+/skytools-(2[0-9.]+).tar.gz debian uupdate
